/*
 * xhtmlundo.h
 * xhtmlite
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */

#include <gtk/gtk.h>

enum {XHTMLITE_UNDO_DELETE, XHTMLITE_UNDO_INSERT, XHTMLITE_UNDO_INSERT_PIXBUF, XHTMLITE_UNDO_ADD_TAG, XHTMLITE_UNDO_REMOVE_TAG};

struct s_xhtmlite_undo_store
{
	int undo_type; 
	gchar *text;
	int start;
	int end;
	GtkTextTag *tag;
};
typedef struct s_xhtmlite_undo_store xhtmlite_undo_store;

void xhtmlite_undo_assign_buttons(GtkTextBuffer *textbuffer, GtkWidget *undo_button, GtkWidget *redo_button);
void xhtmlite_undo_unassign_buttons(GtkTextBuffer *textbuffer);

void xhtmlite_undo_initialize_undos(GtkTextBuffer *textbuffer);
void xhtmlite_undo_clear(GtkTextBuffer *textbuffer);
void xhtmlite_undo_clear_undos(GtkTextBuffer *textbuffer);
void xhtmlite_undo_clear_redos(GtkTextBuffer *textbuffer);

void xhtmlite_undo_add_undo (GtkTextBuffer *textbuffer, GtkTextIter *start, GtkTextIter *end, gchar *text, GtkTextTag *tag, gint undo_type);
void xhtmlite_undo_add_redo (GtkTextBuffer *textbuffer, GtkTextIter *start, GtkTextIter *end, gchar *text, GtkTextTag *tag, gint undo_type);

int xhtmlite_undo_has_undo (GtkTextBuffer *textbuffer);
int xhtmlite_undo_has_redo (GtkTextBuffer *textbuffer);

void xhtmlite_undo_undo (GtkTextBuffer *textbuffer);
void xhtmlite_undo_redo (GtkTextBuffer *textbuffer);
